from charmhelpers.core import hookenv
from cloudfoundry import tasks


def monit_summary(service):
    result = {
        'name': 'monit_summary',
        'health': 'pass',
        'message': None,
        'data': {},
    }
    summary = tasks.monit.summary()
    if summary is None:
        return dict(result, health='fail', message='unable to get summary')
    if any(v != 'Running' for v in summary.values()):
        return dict(result,
                    health='fail',
                    message='not all services running',
                    data={'services': summary})
    return result


def status(service):
    result = {
        'name': 'monit_summary',
        'health': 'pass',
        'message': None,
        'data': {},
    }
    status = hookenv.juju_status()
    if status['status'] == 'error':
        return dict(result, health='fail', message=status['message'])
    elif status['status'] == 'blocked' and status['manual']:
        return dict(result, health='fail', message='Blocked: %s' % status['blockers'])
    elif status['status'] == 'up':
        return result
    else:
        return dict(result, health='warn', message='Working (%s)' % status['status'])
