var Tab = $$({name:null,
              active:null,
              page: null},
             {format: '<a class="item" data-bind="name" />'},
             {'click &': function() {
                 location.hash = this.model.get('name');
                 this.trigger('tab-activated', this);
              },

              'change:active': function(e) {
                  var page = this.model.get('page');
                  if (this.model.get('active') == true) {
                      this.view.$().addClass('active');
                      page.view.$().show();
                  } else {
                      this.view.$().removeClass('active');
                      page.view.$().hide();
                  }
              }
             }
            );


var TabCollection =
$$({tabs: [], active: null},
   {format: '<div class="ui tabular menu" />'},
   {'create': function(){
        var tabs = this.model.get('tabs');
        tabs.forEach(function(t){
            this.append(t);
        }, this);

        this.tabByName = function(name) {
            var result = this.model.get('tabs').filter(function(tab) {
                return tab.model.get('name') == name;
            });
            return result[0];
        };
    },

    'change:active': function(e) {
        var active = this.model.get('active');
        this.model.get('tabs').forEach(function(tab) {
            tab.model.set({active: tab === active});
        });
    },

    'child:tab-activated': function(e, active) {
        this.model.set({active: active});
    }
   });


var Page = $$({content: null,
               title: null},
              {format: '<div class="content" />'},
              {'create': function(e) {
                  // start hidden
                  this.view.$().hide();
              }
              });


var ServiceTitle = $$({name: null,
                       health: null},
                      {format: '<div class="title" style="position: relative">'
                       +   '<div><i class="ui dropdown icon"/>'
                       +   '<span data-bind="name"/></div>'
                       +   '<div data-bind="class=disposition, title=health">'
                       +   '<i data-bind="class=icon"/></div>'
                       + '</div>',
                       style: '& .ui.yellow.label { border-color: #F5C14F; color: #FFFFFF; }'},
                      {'create': function() {
                           var dispositions = {
                               pass: 'ui green corner top right label ok sign icon',
                               warn: 'ui yellow corner top right label attention icon',
                               fail: 'ui red corner top right label remove sign icon',
                           };
                           var icons = {
                               pass: 'ok sign icon',
                               warn: 'attention icon',
                               fail: 'remove sign icon',
                           };
                           this.model.set({disposition: dispositions[this.model.get('health')]});
                           this.model.set({icon: icons[this.model.get('health')]});
                       }});

var HealthCheckResult = $$(
    {name: null, health: null, message: null},
    {format: '<table class="ui table segment">'
           +   '<thead>'
           +     '<tr><th colspan="2" data-bind="name"/></tr>'
           +   '</thead>'
           +   '<tr>'
           +     '<th>Status:</th><td data-bind="health, class=disposition"/>'
           +   '</tr>'
           +   '<tr>'
           +     '<th>Message:</th><td data-bind="message" class="message"/>'
           +   '</tr>'
           + '</table>',
     style: '& .message { max-width: 30em; }'},
    {'create': function() {
         var dispositions = {pass: 'positive',
                             warn: 'warning',
                             fail: 'negative'};
         var health = this.model.get('health');
         this.model.set({disposition: dispositions[health]});
     }});

var ServiceUnitDetails = $$(
    {name: null, state: null, health: null, message: null, checks: []},
    {format: '<div class="ui page dimmer"/>',
     style: '& .page-centered {'
          +   'display: inline-block;'
          +   'margin: auto;'
          +   'font-size: 1.5em;'
          +   'color: black;'
          +   'text-align: left;'
          + '}'
          + '& .page-centered > .ui.label {'
          +   'left: -2.3rem;'
          + '}'
          + '& p.message {'
          +   'max-width: 30em'
          + '}'},
    {create: function() {
         var details = $$({}, '<div class="ui page-centered raised segment"/>');
         this.append($$({}, '<div class="content"/>')
                .append($$({}, '<div class="center"/>')
                    .append(details)));
         details.append($$({label: 'Health Details for ' + this.model.get('name')},
                           '<div data-bind="label" class="ui teal ribbon label"/>'));
         details.append($$(this.model.get(), '<p data-bind="message" class="message"/>'));
         this.model.get('checks').forEach(function(check) {
             details.append($$(HealthCheckResult, check));
         });
     }});

var ServiceUnit = $$({name: null,
                      state: null,
                      health: null,
                      address: null,
                      message: null,
                      checks: []},
                     {format: '<table class="unit-info ui small compact table segment">'
                            +   '<thead><tr><th colspan="2" data-bind="name"/></tr></thead>'
                            +   '<tr><th>State</th><td data-bind="state"/></tr>'
                            +   '<tr><th>Health</th><td data-bind="health, class=disposition"/></tr>'
                            +   '<tr><th>Address</th><td data-bind="address"/></tr>'
                            + '</table>',
                      style: '&.ui.table tbody th,'
                           + '&.ui.table tbody tr:nth-child(2n) {'
                           +    'background-color: transparent;'
                           + '}'
                           + '& .health { cursor: pointer; }'},
                     {'create': function() {
                          var dispositions = {pass: 'health positive',
                                              warn: 'health warning',
                                              fail: 'health negative'};
                          var health = this.model.get('health');
                          this.model.set({disposition: dispositions[health]});
                          this.append($$(ServiceUnitDetails, this.model.get()));
                      },
                      'click .health': function() {
                          this.view.$('.ui.page.dimmer').dimmer('toggle');
                      }});

var ServiceDetails = $$({units: {},
                         relations: {},
                         health: {}},
                        {format: '<div class="content"/>'},
                        {'create': function() {
                             var section = $$({label: null},
                                 '<div class="ui raised segment">'
                               +   '<div class="ui teal ribbon label" data-bind="label"/>'
                               + '</div>');
                             var units_container = $$(section, {label: 'Units'});
                             var relations_container = $$(section, {label: 'Relations'});
                             var charm = this.model.get('charm');
                             var units = this.model.get('units');
                             var relations = this.model.get('relations');
                             var health = this.model.get('health');
                             var charm_container = $$(section, {label: 'Charm'});
                             charm_container.append($$({charm: charm}, '<p data-bind="charm"/>'));
                             for (var unit_name in units) {
                                 var unit = units[unit_name];
                                 var uh = health ? health[unit_name]  : null;
                                 var uhealth = uh ? uh.health : null;
                                 units_container.append($$(ServiceUnit, {
                                     name: unit_name,
                                     state: unit.AgentState,
                                     health: uhealth,
                                     address: unit.PublicAddress,
                                     message: health[unit_name].state.message,
                                     checks: health[unit_name].checks}));
                             }
                             for (var relation_name in relations) {
                                 var relation = relations[relation_name];
                                 var relation_container = $$(
                                     {name: relation_name},
                                     '<table class="ui compact small table segment">'
                                     + '<thead><tr><th data-bind="name"/></tr></thead>'
                                     + '</table>');
                                 relation.forEach(function(endpoint) {
                                     relation_container.append($$(
                                         {endpoint: endpoint},
                                         '<tr><td data-bind="endpoint"/></tr>'
                                     ));
                                 });
                                 relations_container.append(relation_container);
                             }
                             this.append(charm_container);
                             this.append(units_container);
                             this.append(relations_container);
                         }});


var StateCol = $$({label: null},
                  {format: ""
                   + "<div class='ui five wide column'>"
                   + "<div class='ui ribbon label' data-bind='label'/>"
                   + "</div>",
                   style: "&.ui.column { padding-left: 0; }\n"
                   + "& > .ui.ribbon.label { left: -1rem; }"
                   + "&.ui.column.hidden { display: none; }"},
                  {});


var StateCols = $$({},
                   {format:"<div class='ui relaxed page grid'/>"},
                   {});

var State = $$(Page,
               {title:'State',
                data_current: {},
                data_in_flight: [],
                data_target: [],
                children: {},
                columns: {}},
               {},
               {'create':function(){
                   var columns = {current:   $$(StateCol, {label: "Current"}),
                                  in_flight: $$(StateCol, {label: "In Flight"}),
                                  target:    $$(StateCol, {label: "Target"})}
                   var children = {current:   $$({}, '<div class="ui fluid accordion three wide"/>'),
                                   in_flight: $$({}, '<div/>'),
                                   target:    $$({}, '<div/>')};
                   this.model.set({children: children, columns: columns});
                   for (var column in columns) {
                       columns[column].append(children[column]);
                   }
                   this.append(StateCols);
                   StateCols.append(columns.current);
                   StateCols.append(columns.in_flight);
                   StateCols.append(columns.target);
                   var data_if = this.model.get('data_in_flight');
                   var data_tg = this.model.get('data_target');
                   columns.in_flight.view.$().toggleClass('hidden', data_if.length);
                   columns.target.view.$().toggleClass('hidden', data_tg.length);
                },
                'change:data_current': function() {
                    var child = this.model.get('children').current;
                    var data = this.model.get('data_current');
                    child.empty();
                    for (var service in data.Services) {
                        var sh = data.health[service];
                        var health = sh ? sh.health : null;
                        var units = sh ? sh.units : null;
                        child.append($$(ServiceTitle, {
                            name: service,
                            health: health
                        }));
                        child.append($$(ServiceDetails, {
                            charm: data.Services[service].Charm,
                            units: data.Services[service].Units,
                            relations: data.Services[service].Relations,
                            health: units
                        }));
                    }
                    child.view.$().accordion();
                },
                'change:data_in_flight': function() {
                    var columns = this.model.get('columns');
                    var data_if = this.model.get('data_in_flight');
                    columns.in_flight.view.$().toggleClass('hidden', data_if.length);
                },
                'change:data_target': function() {
                    var columns = this.model.get('columns');
                    var data_tg = this.model.get('data_target');
                    columns.target.view.$().toggleClass('hidden', data_tg.length);
                }});


var HealthEntry = $$({service: null,
                      unit: null,
                      rowspan: 1,
                      colspan: 1,
                      health: null,
                      details: null},
                     {format: '<tr/>'},
                     {'create': function() {
                          var dispositions = {pass: 'positive',
                                              warn: 'warning',
                                              fail: 'negative'};
                          var service = this.model.get('service');
                          var unit = this.model.get('unit');
                          var rowspan = this.model.get('rowspan');
                          var health = this.model.get('health');
                          var disposition = dispositions[health]
                          var details = this.model.get('details');
                          if (!details) {
                              details = health == 'pass' ? 'Ok' : 'Not ok';
                          }
                          if (service) {
                              this.append($$(
                                  {service: service,
                                   rowspan: rowspan},
                                  '<th data-bind="service, rowspan=rowspan" class="three wide"/>'));
                          }
                          if (unit) {
                              this.append($$(
                                  {unit: unit,
                                   disposition: disposition + " three wide"},
                                  '<td data-bind="unit, class=disposition"/>'));
                          }
                          this.append($$(
                              {details: details,
                               disposition: disposition,
                               colspan: unit ? 1 : 2},
                              '<td data-bind="details, class=disposition, colspan=colspan"/></tr>'));
                      }});

var Health = $$(Page,
                {title:'Health', data: []},
                {format: '<table class="ui collapsing table segment" style="width: 100%"/>'},
                {'change:data': function() {
                     var data = this.model.get('data');
                     this.empty();
                     data.forEach(function(service) {
                         if (!service.unhealthy_units.length) {
                             this.append($$(HealthEntry, {service: service.name,
                                                          health: service.health,
                                                          details: null}));
                         } else {
                             service.unhealthy_units.forEach(function(unit, i) {
                                 var entry = {unit: unit.name,
                                              health: unit.health,
                                              details: unit.state.message};
                                 if (i == 0) {
                                     entry.service = service.name;
                                     entry.rowspan = service.unhealthy_units.length;
                                 }
                                 this.append($$(HealthEntry, entry));
                             }, this);
                         }
                     }, this);
                 }
                });

var Waterfall = $$(Page, {title:'Waterfall', content: null});
var Logs = $$(Page, {title:'Logs', content: null});


var MessageHandler = function() {
    var $this = this;
    $this.handlers = {
        'health': function(data) {
            Health.model.set({data: data});
        },
        'state.current': function(data) {
            State.model.set({data_current: data});
        }
    };

    $this.dispatch = function(message) {
        var data = JSON.parse(message.data);
        var handler = $this.handlers[data.message_type];
        if (handler) {
            handler(data.message_data);
        } else {
            console.error('Unknown message type:', data.message_type);
        }
    };
    return $this;
};


$(document).ready(
    function() {
        var pagelist = [State, Waterfall, Logs];
        var tabs = pagelist.map(
            function(page) {
                return $$(Tab, {page: page, name: page.model.get('title')});
            });

        var tabcol = $$(TabCollection, {tabs: tabs});
        $$.document.append(tabcol);

        var tab_name = location.hash.replace('#', '');
        tabcol.model.set({active: tabcol.tabByName(tab_name) || tabs[0]});

        pagelist.forEach(function(page){
            $$.document.append(page);
        });

        var protocol = location.protocol.replace('http', 'ws');
        var url = protocol + '//' + location.host + '/dashboard.ws';
        var ws = new ReconnectingWebSocket(url);

        ws.onmessage = new MessageHandler().dispatch;

        ws.onopen = function() {
            console.log("socket opened");
            ws.send(JSON.stringify({message_type: 'state.current'}));
        };

        ws.onclose = function(){
            console.log("socket closed");
        };

        ws.onerror = function(e){
            console.log("socket error");
            console.log(e);
        };
    });
